<#
IT 4 All
Versione 2.8
Roberto Bonfa'
Script creato per la gestione di un PC da parte di un qualunque utente.
Requisiti: saper leggere... :P
Lo script e' composto da tools che automatizzano le operazioni più comuni e basilari
e si spinge fino ad ottimizzare le operazioni più tecniche e decisamente meno comuni
Per alcune parti dello script, ho preso ispirazione da altri script scovati in rete
Sono stati modificati e adattati a mio piacimento.
Riporto quelli di cui ho ritrovato traccia:
###
https://gallery.technet.microsoft.com/scriptcenter/Clean-up-your-C-Drive-bc7bb3ed
https://www.petri.com/building-a-powershell-console-menu-revisited-part-1
https://gallery.technet.microsoft.com/scriptcenter/Get-ExternalPublic-IP-c1b601bb
https://www.petri.com/powershell-problem-solver-find-ip-address-using-powershell
https://blog.mickbadran.com/2016/03/13/keeping-your-isp-honest-a-speed-test/
###
############################################################################################
Vers. 2.8 - Aggiunto speedtest.net
Vers. 2.7 - Aggiunta sezione "Speed Test"
Vers. 2.6 - Aggiunta sezione "Info Dischi"
Vers. 2.5 - Aggiunta sezione "CleanUP"
Vers. 2.4 - Aggiunta sezione "FileASSASSIN" (Sostituito a Unlocker)
Vers. 2.3 - Aggiunta sezione "SuperDelete"
Vers. 2.2 - Aggiunta sezione "Set IP"
Vers. 2.1 - Aggiunta sezione "IP Pubblico"
Vers. 2.0 - Aggiunto Network Speed Test
Vers. 1.9 - Aggiunta possibilita' di rinomina del PC
Vers. 1.8 - Aggiunto ComputerInfo con tutte le info riguardanti tutto il PC
Vers. 1.7 - Aggiunta sezione "Menu Spegnimento"
Vers. 1.6 - Aggiunta sezione "System Admin"
Vers. 1.5 - Aggiunta sezioni "processi"
Vers. 1.4 - Aggiunto get_ip_info_extended
Vers. 1.3 - Aggiunti dati BIOS
Vers. 1.2 - Aggiunto "manufacturer" + classificazione (Major - Minor - Build - Revision)
Vers. 1.1 - Aumentate impostazioni Utente
Vers. 1.0 - Creazione dello script
#>
[console]::ForegroundColor = "Yellow"
[console]::BackgroundColor = "Black"
$menu=@"
####################################### INFORMAZIONI DI BASE SU PC ########################################
 1. Che nome ha il mio PC?
 2. Quanti processori ha il mio PC?
 3. Che architettura ha il processore del mio PC?
 4. Voglio piu' informazioni sul processore del mio PC!
 5. Che sistema operativo utilizza il mio PC?
 6. Che architettura ha il SO del mio PC?
 7. Voglio piu' info: Sistema Operativo + Architettura del SO + Service Pack
 8. Microsoft come classifica il mio SO?
 9. Qual'e' il percorso del mio profilo utente?
10. Chi e' il produttore del mio PC?
11. Posso avere qualche info riguardo il BIOS del mio PC?
12. Sai qualcosa sul mio IP?
13. Altro sul mio IP interno?
14. E... sul mio IP pubblico, cosa sai dirmi?
########################################### PROCESSI DI WINDOWS ###########################################
 a. Quali processi sono attivi ora, su Windows?
 b. Quali sono i processi che contengono solo determinate lettere?
 c. Voglio killare un processo, specificando solo parte del nome!
####################################### AMMINISTRAZIONE DI WINDOWS ########################################
 d. Quali utenti esistono su questo SO? (Comando disponibile solo da Windows 8.1 in poi)
 e. Voglio impostare la password dell'account Administrator del PC (locale)
 f. Voglio abilitare e rendere attivo l'account Administrator del PC (locale)
 g. Voglio rinominare il mio PC!
########################################### PULIZIA DI WINDOWS ############################################
 h. Aiutami a fare pulizia del disco...
###########################################################################################################
############ LE PROSSIME VOCI SONO COMPATIBILI SOLO CON SISTEMI OPERATIVI DA WINDOWS 8.1 IN POI ###########
###########################################################################################################

################################################ IP DEL PC ################################################
 i. Voglio impostare un IP fisso per il mio PC
################################################ Speed Test ###############################################
 s. Voglio testare la velocita' (media) della mia connessione con speedtest.net
 t. Voglio testare la velocita' "teorica" della mia connessione (mb/s)
 u. Voglio testare la velocita' della mia connessione, utilizzando SpeedTest di Ookla
##################################### CANCELLAZIONE FILES E CARTELLE ######################################
 j. Voglio cancellare una cartella o un file per cui Windows dice che il nome e' troppo lungo...
 k. Voglio cancellare un file o una cartella che Windows dice essere in uso...
############################################# INFO SUI DISCHI #############################################
 v. Posso avere piu' info sui miei dischi?
 w. Posso sapere qualcosa sui volumi dei miei dischi?
 x. In quale condizione di salute si trovano i miei dischi?
 y. Posso conoscere qualcosa riguardo i miei "Network Adapter"?
 z. Dimmi tutto, ma proprio tutto sul mio PC...

################################################# USCIRE ##################################################

---> Q Esci <---

Seleziona un'operazione da 1 a 20 oppure premi Q per uscire
"@
<# ----------------------------------------------------------------------------- #>
Function Invoke-Menu {
[cmdletbinding()]
Param(
[Parameter(Position=0,Mandatory=$True,HelpMessage="Seleziona un'opzione per proseguire")]
[ValidateNotNullOrEmpty()]
[string]$Menu,
[Parameter(Position=1)]
[ValidateNotNullOrEmpty()]
[string]$Title = "it4all",
[Alias("Clear-Host")]
[switch]$ClearScreen
)
 
<# Pulizia schermo #>
if ($ClearScreen) { 
 Clear-Host 
}

#build the menu prompt
$menuPrompt = $title
#add a return
$menuprompt+="`n"
#add an underline
$menuprompt+="-"*$title.Length
#add another return
$menuprompt+="`n"
#add the menu
$menuPrompt+=$menu
 
Read-Host -Prompt $menuprompt
 
} #end function
<# ----------------------------------------------------------------------------- #>
Do {
    #use a Switch construct to take action depending on what menu choice
    #is selected.
        Switch (Invoke-Menu -menu $menu -title "it4all"-clear) {
    "1" {Clear-Host
        Write-Host "Il nome del tuo pc e' $Env:ComputerName" -ForegroundColor Yellow
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "`n"
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
         } 
    "2" {
        Clear-Host 
        Write-Host "Il tuo PC ha $env:NUMBER_OF_PROCESSORS processori" -ForegroundColor Green
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "`n"
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
          }
    "3" {
        Clear-Host
        Write-Host "L'architettura dei processori del tuo PC e' $env:PROCESSOR_ARCHITECTURE" -ForegroundColor Magenta
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "`n"
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
         }
    "4" {
        Clear-Host
        Get-WmiObject -Class Win32_Processor -ComputerName . | Select-Object -Property [a-z]*
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
         }
    "5" {
        Clear-Host
        Write-Host "Il sistema operativo (SO) del tuo PC e' $env:OS" -ForegroundColor DarkCyan
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "`n" 
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
        }
    "6" {
        Clear-Host
        Write-Host "Il tuo Sistema Operativo e'"(Get-WmiObject Win32_OperatingSystem).OSArchitecture
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "`n" 
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
        }
    "7" {
        Clear-Host
        Get-WmiObject Win32_OperatingSystem | Select-Object Caption, OSArchitecture, ServicePackMajorVersion
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "`n" 
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
        }
    "8" {
        Clear-Host
        Write-Host "Microsoft classifica il tuo sistema operativo con i seguenti dati:"
        Write-Host "`n"
        [environment]::OSVersion.Version
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "`n" 
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
        }
    "9" {
        Clear-Host
        Write-Host "Il percorso completo del tuo profilo utente e' il seguente:"
        Write-Host "`n"
        $env:USERPROFILE
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "`n" 
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
        }
    "10" {
        Clear-Host
        Write-Host "Il tuo PC e' prodotto da...:"
        Write-Host "`n"
        Get-WmiObject -Class Win32_ComputerSystem
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "`n" 
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
        }
    "11" {
        Clear-Host
        Write-Host "Ecco i dati del BIOS:"
        Write-Host "`n"
        Get-WmiObject -Class Win32_BIOS -ComputerName .
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "`n" 
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
        }
    "12" {
        Clear-Host
        Write-Host "Il tuo IP (interno) - Mac Address e Default Gateway:"
        Write-Host "`n"
        Get-WmiObject -Class Win32_NetworkAdapterConfiguration -Filter 'IPEnabled = True'      
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")            
        }
    "13" {
        Clear-Host
<# Verifico la presenza dello script "IP_Info_Extended.ps1.zip" #>
        $path = "$env:TEMP\IP_Info_Extended.ps1.zip"
        $Test = Test-Path $path 
        If ($Test -eq $True) {Write-Host "Tutti i file necessari per l'esecuzione sono stati scaricati"}
<# Se il file IP_Info_Extended.ps1 non e' presente, lo scarico #>
        Else {
        $url = "https://robertobonfa.com/personal/scripts/IP_Info_Extended.ps1.zip"
        $output = "$env:TEMP\IP_Info_Extended.ps1.zip"
        $start_time = Get-Date

        $wc = New-Object System.Net.WebClient
        $wc.DownloadFile($url, $output)
        #OR
        (New-Object System.Net.WebClient).DownloadFile($url, $output)
            
        Write-Output "Time taken: $((Get-Date).Subtract($start_time).Seconds) second(s)"  
        }
        Write-Host "`n"
<# Verifico la presenza dello script "IP_Info_Extended.ps1" #>
        $path = "$env:TEMP\IP_Info_Extended.ps1"
        $Test = Test-Path $path 
        If ($Test -eq $True) {Write-Host "IP_Info_Extended.ps1 gia' scaricato e decompresso"}
<# Se il file IP_Info_Extended.ps1 non e' presente, lo decomprimo dall'archivio scaricato#>
        Else {
        Expand-Archive -Path "$env:TEMP\IP_Info_Extended.ps1.zip" -DestinationPath "$env:TEMP"
        }
        Clear-Host
        Write-Host "Il tuo IP (interno) - Mac Address e Default Gateway:"
        & "$env:TEMP\IP_Info_Extended.ps1"
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")            
        }
    "14" {
        Clear-Host
        Write-Host "Ecco tutto cio' che conosco sul tuo IP pubblico, il tuo provider e dove sei geolocalizzato:"
        Write-Host "`n"
        $ipinfo = Invoke-RestMethod https://ipinfo.io/json 
        $ipinfo.ip 
        $ipinfo.hostname 
        $ipinfo.city 
        $ipinfo.region 
        $ipinfo.country 
        $ipinfo.loc 
        $ipinfo.org
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "`n" 
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
        }
<#
###########################################################################################################
########################################### Processi di Windows ###########################################
###########################################################################################################
#>
    "a" {
        Clear-Host
        Write-Host "Ecco la lista di tutti i processi:"
        Write-Host "`n"
        Get-Process     
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")            
        }
    "b" {
        Clear-Host
        $ProcessPartialName = Read-Host "Specifica il nome o alcune lettere del processo che vuoi cercare"
        Write-Host "`n"
        Write-Host "Ecco la lista di tutti i processi:"
        Get-Process -ProcessName "*$ProcessPartialName*"      
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")            
        }
    "c" {
        Clear-Host
        $ProcessName = Read-Host "Qual'e' il nome - per esteso - del processo che vuoi killare"
        Write-Host "`n"
        Get-Process -ProcessName "*$ProcessName*" | Stop-Process -Force
        Write-Host "I processi che contengono la stringa $ProcessName sono stati killati!"      
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")            
        }
<#
###########################################################################################################
######################################## Amministrazione di Windows #######################################
###########################################################################################################
#>
    "d" {
        Clear-Host
        Write-Host "Ecco gli account esistenti per questo Windows..."
        Write-Host "`n"
        Get-LocalUser 
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")            
        }
    "e" {
        Clear-Host
        Write-Host "Stai impostando la password per l'account Administrator, presta attenzione!" -ForegroundColor Red
        Write-Host "`n"
        net user administrator *
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
       Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")            
        }
    "f" {
        Clear-Host
        net user administrator /active:yes
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")            
        }
    "g" {
        Clear-Host
        Write-Host "ATTENZIONE: la modifica riavviera' immediatamente il PC!" -ForegroundColor Red
        Write-Host "`n"
        $NewName = Read-Host "Inserisci il nuovo nome che vuoi assegnare a questo PC" -ForegroundColor DarkYellow
        Rename-Computer -NewName "$NewName" -LocalCredential .\Administrator -Restart -Confirm
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")            
        }
<#
###########################################################################################################
############################################ Pulizia di Windows ###########################################
###########################################################################################################
#>
"h" {
    Clear-Host
<# Verifico la presenza dello script "CleanUP_Windows.ps1.zip" #>
    $path = "$env:TEMP\CleanUP_Windows.ps1.zip"
    $Test = Test-Path $path 
    If ($Test -eq $True) {Write-Host "Tutti i file necessari per l'esecuzione sono stati scaricati"}
<# Se il file CleanUP_Windows.ps1 non e' presente, lo scarico #>
    Else {
    $url = "https://robertobonfa.com/personal/scripts/CleanUP_Windows.ps1.zip"
    $output = "$env:TEMP\CleanUP_Windows.ps1.zip"
    $start_time = Get-Date
    
    $wc = New-Object System.Net.WebClient
    $wc.DownloadFile($url, $output)
    #OR
    (New-Object System.Net.WebClient).DownloadFile($url, $output)
    
    Write-Output "Time taken: $((Get-Date).Subtract($start_time).Seconds) second(s)"  
}
    Write-Host "`n"
<# Verifico la presenza dello script "CleanUP_Windows.ps1" #>
    $path = "$env:TEMP\CleanUP_Windows.ps1"
    $Test = Test-Path $path 
    If ($Test -eq $True) {Write-Host "CleanUP_Windows.ps1 gia' scaricato e decompresso"}
<# Se il file CleanUP_Windows.ps1 non e' presente, lo decomprimo dall'archivio scaricato #>
    Else {
    Expand-Archive -Path "$env:TEMP\CleanUP_Windows.ps1.zip" -DestinationPath "$env:TEMP"
}
    Write-Host "`n"
& "$env:TEMP\CleanUP_Windows.ps1"      
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
    Write-Host "Premi un tasto per tornare al menu"
    $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")            
    }
<#
###########################################################################################################
########## Le prossime voci sono compatibili solo con sistemi operativi da Windows 8.1 in poi... ##########
###########################################################################################################
#>
<#
###########################################################################################################
############################################ Impostare IP fisso ###########################################
###########################################################################################################
#>
"i" {
    Clear-Host
    $IP = "10.10.10.10"
    $MaskBits = 24 # Questa e' la subnet e significa che verra' impostata 255.255.255.0
    $Gateway = "10.10.10.1"
    $Dns = "10.10.10.100"
    $IPType = "IPv4"
    # Retrieve the network adapter that you want to configure
    $adapter = Get-NetAdapter | ? {$_.Status -eq "up"}
    # Remove any existing IP, gateway from our ipv4 adapter
    If (($adapter | Get-NetIPConfiguration).IPv4Address.IPAddress) {
     $adapter | Remove-NetIPAddress -AddressFamily $IPType -Confirm:$false
    }
    If (($adapter | Get-NetIPConfiguration).Ipv4DefaultGateway) {
     $adapter | Remove-NetRoute -AddressFamily $IPType -Confirm:$false
    }
     # Configure the IP address and default gateway
    $adapter | New-NetIPAddress `
     -AddressFamily $IPType `
     -IPAddress $IP `
     -PrefixLength $MaskBits `
     -DefaultGateway $Gateway
    # Configure the DNS client server IP addresses
    $adapter | Set-DnsClientServerAddress -ServerAddresses $DNS      
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
    Write-Host "Premi un tasto per tornare al menu"
    $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")            
    }
<#
###########################################################################################################
############################################### Speed Test ################################################
###########################################################################################################
#>
"s" {
    Clear-Host
<# Verifico la presenza speedtest.zip all'interno della cartella "temp" #>
    $path = "$env:TEMP\speedtest.zip"
    $Test = Test-Path $path 
    If ($Test -eq $True) {Write-Host "File zip gia' scaricato!"}
<# Se il file speedtest.zip non e' presente, lo scarico #>
    Else {
    $url = "https://robertobonfa.com/personal/scripts/speedtest.zip"
    $output = "$env:TEMP\speedtest.zip"
    $start_time = Get-Date
    $wc = New-Object System.Net.WebClient
    $wc.DownloadFile($url, $output)
    #OR
    (New-Object System.Net.WebClient).DownloadFile($url, $output)
    Write-Output "Time taken: $((Get-Date).Subtract($start_time).Seconds) second(s)"  
}
    Write-Host "`n"
<# Verifico la presenza del file speedtest.exe #>
    $path = "$env:TEMP\speedtest.exe"
    $Test = Test-Path $path 
    If ($Test -eq $True) {Write-Host "speedtest.exe gia' scaricato e zip gia' decompresso"}
<# Se il file speedtest.exe non e' presente, lo decomprimo #>
    Else {
    Expand-Archive -Path "$env:TEMP\speedtest.zip" -DestinationPath "$env:TEMP"
}
    Clear-Host
<# Eseguo speedtest.exe con il parametro avg (average speed) #>
    & cmd.exe /C "$env:TEMP\speedtest.exe" -a avg
    Write-Host "`n"
    Write-Host "Qui sopra le medie: ping | velocita' di download | velocita' di upload. Piu' sopra trovi ID del server - citta' e (nome della societa' che ospita il server)" -ForegroundColor Green
    Write-Host "`n"
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
    Write-Host "Premi un tasto per tornare al menu"
    $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")            
    }
"t" {
    Clear-Host
    Write-Host "Sto scaricando un file temporaneo da 100MB. Attendi..." -ForegroundColor Green
    $Request = Get-Date; Invoke-WebRequest 'https://ping.virtua.cloud/100MB.bin' | Out-Null;
    [int]$speed = ((10 / ((New-TimeSpan -Start $Request -End (Get-Date)).totalseconds)) * 8)
    "{0:N2}" -f $Speed
    Clear-Host
    Write-Host "La velocita' espressa e' quella massima teorica (arrotondata)!" -ForegroundColor Red
    Write-Host "`n"
    Write-host "$($speed) Mbit/sec"
    Write-Host "`n"
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
    Write-Host "Premi un tasto per tornare al menu"
    $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")            
    }
"u" {
    Clear-Host
    # Imposto l'URL dell'installer della CLI di Speedtest (verificate sempre l'URL per eventuali aggiornamenti)
	$url = "https://install.speedtest.net/app/cli/ookla-speedtest-1.2.0-win64.zip"
	# Imposto il percorso in cui salvare il file ZIP scaricato
	$zipPath = "$env:TEMP\ookla-speedtest.zip"
	# Imposto la directory di destinazione per l'installazione
	$destPath = "C:\Speedtest"
	# Scarico l'installer
	Invoke-WebRequest -Uri $url -OutFile $zipPath
	# Estraggo il contenuto del file ZIP
	Expand-Archive -LiteralPath $zipPath -DestinationPath $destPath -Force
	# Aggiungo il percorso dell'eseguibile al PATH, se necessario, per poterlo eseguire da qualsiasi directory
	$env:Path += ";$destPath"
	# Verifico l'installazione eseguendo la CLI di Speedtest
	& "$destPath\speedtest.exe" --version
	# Eseguo lo speedtest
	& "speedtest"
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
    Write-Host "Premi un tasto per tornare al menu"
    $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")            
    }
<#
###########################################################################################################
################################### Sblocco e rimozione file e cartelle ###################################
###########################################################################################################
#>
"j" {
    Clear-Host
<# Verifico la presenza del file SuperDelete_1.2.0_x86-x64_NET40.zip #>
    $path = "$env:TEMP\SuperDelete_1.2.0_x86-x64_NET40.zip"
    $Test = Test-Path $path 
    If ($Test -eq $True) {Write-Host "File zip gia' scaricato!"}
<# Se il file SuperDelete_1.2.0_x86-x64_NET40.zip non e' presente, lo scarico #>
    Else {
    $url = "https://robertobonfa.com/personal/scripts/SuperDelete_1.2.0_x86-x64_NET40.zip"
    $output = "$env:TEMP\SuperDelete_1.2.0_x86-x64_NET40.zip"
    $start_time = Get-Date
    
    $wc = New-Object System.Net.WebClient
    $wc.DownloadFile($url, $output)
    #OR
    (New-Object System.Net.WebClient).DownloadFile($url, $output)
    
    Write-Output "Time taken: $((Get-Date).Subtract($start_time).Seconds) second(s)"  
}
    Write-Host "`n"
<# Verifico la presenza del file SuperDelete.exe #>
    $path = "$env:TEMP\SuperDelete.exe"
    $Test = Test-Path $path 
    If ($Test -eq $True) {Write-Host "Superdelete.exe gia' scaricato e decompresso"}
<# Se il file SuperDelete.exe non e' presente, lo decomprimo #>
    Else {
    Expand-Archive -Path "$env:TEMP\SuperDelete_1.2.0_x86-x64_NET40.zip" -DestinationPath "$env:TEMP"
}
    Write-Host "`n"
<# Costruisco la GUI per la richiesta del percorso del file o cartella da eliminare #>
    [void][System.Reflection.Assembly]::LoadWithPartialName('Microsoft.VisualBasic') 
    $Path = [Microsoft.VisualBasic.Interaction]::InputBox('Inserisci il path completo del file/cartella da eliminare', 'PATH')

    $Path

    & cmd.exe /C "$env:TEMP\SuperDelete.exe" -s $Path     
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
    Write-Host "Premi un tasto per tornare al menu"
    $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")            
    }
"k" {
    Clear-Host
<# Verifico la presenza FileASSASSIN.zip all'interno di una cartella FileASSASSIN che deve essere dove risiede lo script #>
    $path = "$env:TEMP\FileASSASSIN.zip"
    $Test = Test-Path $path 
    If ($Test -eq $True) {Write-Host "File zip gia' scaricato!"}
<# Se il file FileASSASSIN.zip non e' presente, lo scarico #>
    Else {
    $url = "https://robertobonfa.com/personal/scripts/FileASSASSIN.zip"
    $output = "$env:TEMP\FileASSASSIN.zip"
    $start_time = Get-Date
    $wc = New-Object System.Net.WebClient
    $wc.DownloadFile($url, $output)
    #OR
    (New-Object System.Net.WebClient).DownloadFile($url, $output)
    Write-Output "Time taken: $((Get-Date).Subtract($start_time).Seconds) second(s)"  
}
    Write-Host "`n"
<# Verifico la presenza del file FileASSASSIN.exe #>
    $path = "$env:TEMP\FileASSASSIN.exe"
    $Test = Test-Path $path 
    If ($Test -eq $True) {Write-Host "FileASSASSIN.exe gia' scaricato e zip gia' decompresso"}
<# Se il file FileASSASSIN.exe non e' presente, lo decomprimo #>
    Else {
    Expand-Archive -Path "$env:TEMP\FileASSASSIN.zip" -DestinationPath "$env:TEMP"
}
    Write-Host "`n"
<# Costruisco la GUI per la richiesta del percorso del file o cartella da eliminare #>
    [void][System.Reflection.Assembly]::LoadWithPartialName('Microsoft.VisualBasic') 
    $Path = [Microsoft.VisualBasic.Interaction]::InputBox('Inserisci il path completo del file da eliminare', 'PATH') 
    $Path
    & cmd.exe /C "$env:TEMP\FileASSASSIN.exe" /assassinate /silent "$Path"      
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
    Write-Host "Premi un tasto per tornare al menu"
    $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")            
    }
<#
###########################################################################################################
############################################## Info sui dischi ############################################
###########################################################################################################
#>
    "v" {
        Clear-Host
        Write-Host "Ecco quello che devi sapere sui tuoi dischi:"
        Get-Disk
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "`n" 
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
        }
    "w" {
        Clear-Host
        Write-Host "Di sequito trovi le info che volevi riguardo i volumi dei tuoi dischi:"
        Get-Volume
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "`n" 
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
        }
    "x" {
        Clear-Host
        Write-Host "Di seguito lo stato di salute dei tuoi dischi:"
        Get-PhysicalDisk
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "`n" 
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
        }
    "y" {
        Clear-Host
        Write-Host "Ecco i dati dei tuoi Network Adapter:"
        Get-NetAdapter
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "`n" 
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
        }
    "z" {
        Clear-Host
        Write-Host "Ecco ogni dato del tuo PC:"
        Get-ComputerInfo
<# Fermo lo script con il risultato. Premere un tasto per tornare al menu principale #>
        Write-Host "`n" 
        Write-Host "Premi un tasto per tornare al menu"
        $x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
        }
    "Q" {
        Clear-Host
        Write-Host "`n"
        Write-Host "
         ___  ____    __    _____        __      ____  ____  ____  ___  ____  _____ /\
        / __)(_  _)  /__\  (  _  )      /__\    (  _ \(  _ \( ___)/ __)(_  _)(  _  ))(
       ( (__  _)(_  /(__)\  )(_)(      /(__)\    )___/ )   / )__) \__ \  )(   )(_)( \/
        \___)(____)(__)(__)(_____)()  (__)(__)  (__)  (_)\_)(____)(___/ (__) (_____)()
       
"
        sleep -seconds 3
        Clear-Host
        Return
        }
     Default {Write-Warning "La tua selezione non e' valida, riprova..."
              sleep -milliseconds 750}
    } #switch
} While ($True)